Unit
  DBVDlg;  { Data Base Viewer Dialog
             (C) V. Kulimov, 1995-96 }

Interface

Uses
  Dialogs, Drivers, Views, DBServ, Tools, Scrollb;

Const
  cmInfo  = 1002;
  cmHead  = 1003;
  cmToBin = 1004;
  cmText  = 1005;

Type
  PDBViewDialog = ^TDBViewDialog;
  TDBViewDialog = Object(TDialog)
    DBFile: PDBFile;
    LB: PScrollLB;
    Constructor Init(F: PDBFile; ATitle: TTitleStr; AHeader: TTitleStr);
    Procedure HandleEvent(var Event: TEvent); Virtual;
  End;

  PFieldStaticText = ^TFieldStaticText;
  TFieldStaticText = Object(TStaticText)
    Procedure Draw; Virtual;
  End;


Implementation

Uses
   Objects, App, MsgBox;

Constructor TDBViewDialog.Init(F: PDBFile; ATitle: TTitleStr; AHeader: TTitleStr);
Var
  R: TRect;
  P, S: PScrollBar;
  T: PFieldStaticText;
Begin
  Application^.GetExtent(R);
  R.Grow(0, -1);
  Inherited Init(R, ATitle);

  DBFile := F;
  Options  := Options or ofCentered;
  R.Grow(-1, -1);
  R.B.Y := R.A.Y + 1;
  R.Move(0, -1);
  T := New(PFieldStaticText, Init(R, AHeader));
  Insert(T);

  GetExtent(R);
  R.Grow(-1, -1);
  R.A.X := R.B.X - 1;
  Dec(R.B.Y);
  R.Move(1, 1);
  P := New(PScrollBar, Init(R));
  Insert(P);

  GetExtent(R);
  R.Grow(-1, -1);
  R.A.Y := R.B.Y - 1;
{  Dec(R.B.Y); }
  R.Move(0, 1);
  S := New(PScrollBar, Init(R));
  Insert(S);


  GetExtent(R);
  R.Grow(-1, -1);
  Inc(R.A.Y);
  LB := New(PScrollLB, Init(R, 1, S, P, F^.RecSize + 1));
  Insert(LB);
End;

Procedure TDBViewDialog.HandleEvent(var Event: TEvent);
Var
  S: String;
Begin
  Inherited HandleEvent(Event);
  if Event.What = evCommand then
  Case Event.Command of
    cmQuit: EndModal(cmOk);
    cmInfo: DBFile^.GetInfo;
    cmHead: DBFile^.WriteHeader;
    cmText: Begin
              DBFile^.MakeText(LB^.List);
              MakeFirst
            End;
    cmToBin: Begin
               S := '';
               ShowCursor;
               if InputBox('  䠩',
                           ' 䠩  Pascal', S, 40) = cmOk then
                  DBFile^.ToBinary(S);
               HideCursor;
             End;
  End;
End;

Procedure TFieldStaticText.Draw;
var
  B: TDrawBuffer;
  C: Byte;
  S: String;
begin
  C := GetColor(1);
  GetText(S);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, S, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

End.

